/* Author: Chris Culy
 * Date: 2014
 * License: Public domain
 */
function simpleChiSquareProb(observed, ns) {
    //works for 2 or 3 values
    
    //threshold for too small:
    var thresh = 40;
    
    
    var totalN = 0;
    var observedN = 0;
    for(var i=0,n=observed.length;i<n;i++) {
        totalN += ns[i];
        observedN += observed[i];
    }
    
    if (observedN < thresh) {
        return null;
    }
    
    var proportion = observedN/totalN;
    
    var chi2 = 0;
    for(var i=0,n=observed.length;i<n;i++) {
        var expected = ns[i]*proportion;
        chi2 += (observed[i] - expected)*(observed[i] - expected)/expected;
    }
    var df = observed.length -1;
    
    //p<  0.05, 0.01, 0.005, 0.001
    var probs = [0.05, 0.01, 0.005, 0.001];
    var ps = [
      [],
      [3.8145, 6.6349, 7.8794, 10.8276],
      [5.9915, 9.2104, 10.5965, 13.8155]
    ];
    
    var what = ""; //NOT significant at 0.05";
    
    for(var i=3;i>-1;i--) {
        if (chi2 > ps[df][i]) {
            what = "p < " + probs[i];
            break;
        }
    }
    return what;
}