/* (This is the new BSD license.)
* Copyright (c) 2014, Chris Culy
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the Chris Culy nor the 
*		names of its contributors may be used to endorse or promote 
*		products from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY Chris Culy
* ``AS IS'' AND ANY OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
* THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
* ARE DISCLAIMED. IN NO EVENT SHALL Chris Culy
* BE LIABLE FOR ANY, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
* CONSEQUENTIAL DAMAGES INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
* GOODS OR SERVICES; OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
* CAUSED AND ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
* TORT INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
* THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
function pushHistory(searchTerm) {
  var howMany = kwic.hitsCount();
  itemHistory.pushItem(searchTerm, {'hits':howMany});
  var select = document.getElementById("searchHistory");
  var opts = itemHistory.getAll().map(function(d,i) {
    var item = d[0].toString().replace(/<unknown>/g, '&lt;unknown&gt;').replace(/"/g,'&quot;');
    var what = '<option value="' + i + '" class="';
    if (d[1].hits > 0) {
      what += 'found">' + item + '\t(' + d[1].hits + ')';
    } else {
      what += 'missed" disabled>' + item + '\t(0)';
    }
    what += '</option>';
    return what;
  }).reverse(); //most recent on top
  select.innerHTML = opts.join("\n");
  
  
}
function clearHistory() {
  itemHistory.removeAll();
  var select = document.getElementById("searchHistory").innerHTML = "";
}

function setFromHistory(which) {
  var item = itemHistory.getAll()[which][0];
  setSearchTerm(item);
  makeKWICandUpdate();
}